//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  DodgerBlue
#property indicator_color2  Red

//
//
//
//
//

extern int    EnvelopePeriod  = 288;
extern int    EnvelopeMaShift = 0;
extern int    EnvelopeMaMode  = MODE_EMA;
extern int    UpperPrice      = 0;
extern int    LowerPrice      = 0;
extern double Deviation       = 0.15;
extern int    MaPeriod        = 89;
extern int    MaShift         = 0;
extern int    MaMode          = MODE_EMA;
extern int    MaPrice         = PRICE_CLOSE;
extern int    arrowSize       = 2;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

//
//
//
//
//

double arrowUp[];
double arrowDn[];
double UpEnv[];
double DnEnv[];
double Ma[];
double trend[];

//
//
//
//                    
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,arrowUp); SetIndexStyle(0,DRAW_ARROW,0,arrowSize); SetIndexArrow(0,241);
   SetIndexBuffer(1,arrowDn); SetIndexStyle(1,DRAW_ARROW,0,arrowSize); SetIndexArrow(1,242);
   SetIndexBuffer(2,UpEnv);  SetIndexShift(2,EnvelopeMaShift);
   SetIndexBuffer(3,DnEnv);  SetIndexShift(3,EnvelopeMaShift);
   SetIndexBuffer(4,Ma);     SetIndexShift(4,MaShift);
   SetIndexBuffer(5,trend);
   
   IndicatorShortName("Envelope Ma("+EnvelopePeriod+","+MaPeriod+")");
   
   
return(0);
}  
  
//+------------------------------------------------------------------
//|                             
//+------------------------------------------------------------------
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
   
   for (i = limit; i >= 0; i--)
   {
      UpEnv[i] = (1+Deviation/100)*iMA(NULL,0,EnvelopePeriod,EnvelopeMaShift,EnvelopeMaMode,UpperPrice,i);
      DnEnv[i] = (1-Deviation/100)*iMA(NULL,0,EnvelopePeriod,EnvelopeMaShift,EnvelopeMaMode,LowerPrice,i);
      Ma[i]    = iMA(NULL,0,MaPeriod,MaShift,MaMode,MaPrice,i);
      
      trend[i] = trend[i+1];
         if (Ma[i]>UpEnv[i]) trend[i] = 1;
         if (Ma[i]<DnEnv[i]) trend[i] =-1;
         if (trend[i] != trend[i+1])
         if (trend[i]==1) 
               arrowUp[i] = Low[i]  - iATR(NULL,0,20,i)/2;
         else  arrowDn[i] = High[i] + iATR(NULL,0,20,i)/2;
         }

         //
         //
         //
         //
         //
         
         if (alertsOn)
         {
         if (alertsOnCurrent)
              int whichBar = 0;
         else     whichBar = 1;

         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert("uptrend");
         else  doAlert("downtrend");       
   }
   
   return(0);
}
//+------------------------------------------------------------------+


void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ma cross envelope ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," ma cross envelope "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}
 
   

